DEFINE VARIABLE hCache AS HANDLE NO-UNDO.
DEFINE VARIABLE hTbl AS HANDLE NO-UNDO.
DEFINE VARIABLE cFileName AS CHARACTER NO-UNDO.
DEFINE VARIABLE cError AS CHARACTER NO-UNDO.
DEFINE VARIABLE iNumberOfPages AS INTEGER NO-UNDO.

DEFINE TEMP-TABLE Results
  FIELD FirstName AS CHARACTER
  FIELD LastName AS CHARACTER
  FIELD Order AS INTEGER.
  
DEFINE TEMP-TABLE PagedResults LIKE Results.

CREATE Results.

ASSIGN
Results.FirstName = "1f"
Results.LastName = "1l"
Results.Order = 1.

CREATE Results.

ASSIGN
Results.FirstName = "2f"
Results.LastName = "2l"
Results.Order = 2.

CREATE Results.

ASSIGN
Results.FirstName = "3f"
Results.LastName = "3l"
Results.Order = 3.

CREATE Results.

ASSIGN
Results.FirstName = "4f"
Results.LastName = "4l"
Results.Order = 4.

CREATE Results.

ASSIGN
Results.FirstName = "5f"
Results.LastName = "5l"
Results.Order = 5.

CREATE Results.

ASSIGN
Results.FirstName = "6f"
Results.LastName = "6l"
Results.Order = 6.

CREATE Results.

ASSIGN
Results.FirstName = "7f"
Results.LastName = "7l"
Results.Order = 7.

CREATE Results.

ASSIGN
Results.FirstName = "8f"
Results.LastName = "8l"
Results.Order = 8.

RUN cachemgr.p PERSISTENT SET hCache.

RUN WriteDataToDisk IN hCache
(INPUT TEMP-TABLE Results:HANDLE, 
OUTPUT cFileName).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "WriteDataToDisk<BR>".
{&OUT} "Error " cError "<BR>".
{&OUT} "File Name " cFileName "<BR>".

EMPTY TEMP-TABLE Results.

RUN ReadDataFromDisk IN hCache
(INPUT cFileName, 
 INPUT TEMP-TABLE Results:HANDLE).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReadDataFromDisk<BR>".
{&OUT} "Error " cError "<BR>".
{&OUT} "File Name " cFileName "<BR>".


RUN DetermineNumberPages IN hCache
(INPUT 4, 
 OUTPUT iNumberOfPages).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReadDataFromDisk<BR>".
{&OUT} "Error " cError "<BR>".
{&OUT} "iNumberOfPages " iNumberOfPages "<BR>".

/* Test nice mod of entries per page */



/* Page 1 */

EMPTY TEMP-TABLE PagedResults.

RUN ReturnPageResults IN hCache
(INPUT 1,
 INPUT 4, 
 TEMP-TABLE PagedResults:HANDLE).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReturnPageResults<BR>".
{&OUT} "Error " cError "<BR>".

FOR EACH PagedResults NO-LOCK:
  {&DISPLAY} PagedResults.
END.





/* Page 2 */

EMPTY TEMP-TABLE PagedResults.

RUN ReturnPageResults IN hCache
(INPUT 2,
 INPUT 4, 
 TEMP-TABLE PagedResults:HANDLE).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReturnPageResults<BR>".
{&OUT} "Error " cError "<BR>".

FOR EACH PagedResults NO-LOCK:
  {&DISPLAY} PagedResults.
END.



/* Test nasty mod of entries per page */



/* Page 1 */

EMPTY TEMP-TABLE PagedResults.

RUN ReturnPageResults IN hCache
(INPUT 1,
 INPUT 3, 
 TEMP-TABLE PagedResults:HANDLE).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReturnPageResults<BR>".
{&OUT} "Error " cError "<BR>".

FOR EACH PagedResults NO-LOCK:
  {&DISPLAY} PagedResults.
END.





/* Page 2 */

EMPTY TEMP-TABLE PagedResults.

RUN ReturnPageResults IN hCache
(INPUT 2,
 INPUT 3, 
 TEMP-TABLE PagedResults:HANDLE).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReturnPageResults<BR>".
{&OUT} "Error " cError "<BR>".

FOR EACH PagedResults NO-LOCK:
  {&DISPLAY} PagedResults.
END.


/* Page 3 */

EMPTY TEMP-TABLE PagedResults.

RUN ReturnPageResults IN hCache
(INPUT 3,
 INPUT 3, 
 TEMP-TABLE PagedResults:HANDLE).

RUN GetError IN hCache (OUTPUT cError).

{&OUT} "ReturnPageResults<BR>".
{&OUT} "Error " cError "<BR>".

FOR EACH PagedResults NO-LOCK:
  {&DISPLAY} PagedResults.
END.




DELETE OBJECT hCache.
